package com.sxtvs.open.api.review.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sxtvs.open.api.h5template.service.impl.OSSService;
import com.sxtvs.open.api.review.dto.PageReqDTO;
import com.sxtvs.open.api.review.entity.ReviewImgRecord;
import com.sxtvs.open.api.review.entity.ReviewVideosRecord;
import com.sxtvs.open.api.review.service.impl.ReviewVideosRecordServiceImpl;
import com.sxtvs.open.core.auth.LoginRequired;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2024-02-05
 */
@RestController
@RequestMapping("/review/video")
public class ReviewVideosRecordController {

    @Resource
    private ReviewVideosRecordServiceImpl reviewVideoRecordService;

    @Resource
    private OSSService ossService;

    @PostMapping("upload")
    @LoginRequired
    public Map<String, String> upload(MultipartFile file){
        return Map.of("url", ossService.vcrPut(file));
    }

    @PostMapping("uploads")
    @LoginRequired
    public void upload(@RequestParam("title") String title, @RequestParam("files") MultipartFile[] file){
        for( MultipartFile multipartFile : file){
            ReviewVideosRecord reviewVideosRecord = new ReviewVideosRecord();
            reviewVideosRecord.setTitle(title);
            reviewVideosRecord.setUrl(ossService.vcrPut(multipartFile));
            reviewVideoRecordService.store(reviewVideosRecord);
        }
    }

    @PostMapping("store")
    @LoginRequired
    public ReviewVideosRecord store(@RequestBody ReviewVideosRecord reviewVideosRecord){
        return reviewVideoRecordService.store(reviewVideosRecord);
    }

    @PostMapping("list")
    @LoginRequired
    public Page<ReviewVideosRecord> list(@RequestBody PageReqDTO pageReqDTO){
        return reviewVideoRecordService.list(pageReqDTO);
    }

    @GetMapping("del")
    @LoginRequired
    public void del(@RequestParam("id") Long id){
        reviewVideoRecordService.removeById(id);
    }
}
